'use strict';

var CompraServices = angular.module('CompraServices', []);

MaterialServices.factory('Compra', ['Conexao',
    function (Conexao) {

        var compraFactory = {};

        compraFactory.setNotaFiscal = (notaFiscal, callBackFunction) => {
            var params = {
                POST: true,
                data: notaFiscal
            }
            Conexao.ExecutaService('setNotaFiscalPost', params, true,
                (data) => {
                    callBackFunction(data);
                });
        }

        compraFactory.salvaLogArquivo = (log, callBackFunction) => {
            var params = {
                POST: true,
                data: log
            }
            Conexao.ExecutaService('salvaLogArquivo', params, false,
                (data) => {
                    callBackFunction(data);
                });
        }

        compraFactory.ConciliaExtratoOfx = (ofxFile, callBackFunction) => {
            var params = {
                POST: true,
                data: ofxFile
            }
            Conexao.ExecutaService('ConciliaExtratoOfx', params, true,
                (data) => {
                    callBackFunction(data);
                });
        }

        compraFactory.getNotasFiscais = (idConstrucao, idNotaFiscal, callBackFunction) => {
            Conexao.ExecutaService('getNotasFiscais', { IdConstrucao: idConstrucao, IdNotaFiscal: idNotaFiscal }, false,
                (data) => {
                    callBackFunction(data);
                });
        }

        compraFactory.getNotasFiscaisPaginacao = (params, callBackFunction) => {
            Conexao.ExecutaService('getNotasFiscais', params, false,
                (data) => {
                    callBackFunction(data);
                });
        }

        compraFactory.setMateriaisComprado = (materiais, callBackFunction) => {
            var params = {
                POST: true,
                data: materiais
            }
            Conexao.ExecutaService('setMateriaisCompradoPost', params, true,
                (data) => {
                    callBackFunction(data);
                });
        }

        compraFactory.getMateriaisComprado = (material, callBackFunction) => {
            Conexao.ExecutaService('getMateriaisComprado', material, false,
                (data) => {
                    callBackFunction(data);
                });
        }
        
        compraFactory.getComprovante = (IdComprovante, callBackFunction) => {
            Conexao.ExecutaService('getComprovante', { IdComprovante: IdComprovante }, true,
                (data) => {
                    callBackFunction(data);
                });
        }

        compraFactory.delNotaFiscal = (idNotaFiscal, callBackFunction) => {
            Conexao.ExecutaService('delNotaFiscal', { IdNotaFiscal: idNotaFiscal }, false,
                (data) => {
                    callBackFunction(data);
                });
        }

        compraFactory.getArquivoNotaFiscal = (idNotaFiscal, callBackFunction) => {
            Conexao.ExecutaService('getArquivoNotaFiscal', { IdNotaFiscal: idNotaFiscal }, false,
                (data) => {
                    callBackFunction(data);
                });
        }

        compraFactory.delArquivoNotaFiscal = (Id, callBackFunction) => {
            Conexao.ExecutaService('delArquivoNotaFiscal', { Id: Id }, true,
                (data) => {
                    callBackFunction(data);
                });
        }

        compraFactory.setMaterialAvancoFisico = (material, callBackFunction) => {
            Conexao.ExecutaService('setMaterialAvancoFisico', { materialJson: material }, true,
                (data) => {
                    callBackFunction(data);
                });
        }

        compraFactory.setMateriaisAvancoFisico = (materiais, callBackFunction) => {
            Conexao.ExecutaService('setMateriaisAvancoFisico', { materiaisJson: materiais }, true,
                (data) => {
                    callBackFunction(data);
                });
        }
        
        compraFactory.setAvancoFisicoEtapa = (medicao, callBackFunction) => {
            Conexao.ExecutaService('setAvancoFisicoEtapa', medicao, true,
                (data) => {
                    callBackFunction(data);
                });
        }

        compraFactory.setParcela = (parcela, callBackFunction) => {
            Conexao.ExecutaService('setParcela', parcela, true,
                (data) => {
                    callBackFunction(data);
                });
        }

        compraFactory.delParcela = (IdParcela, callBackFunction) => {
            Conexao.ExecutaService('delParcela', {IdParcela: IdParcela}, true,
                (data) => {
                    callBackFunction(data);
                });
        }

        compraFactory.getParcelas = (IdNotaFiscal, callBackFunction) => {
            Conexao.ExecutaService('getParcelas', {IdNotaFiscal: IdNotaFiscal}, false,
                (data) => {
                    callBackFunction(data);
                });
        }

        compraFactory.setParcelaPaga = (parcela, callBackFunction) => {
            Conexao.ExecutaService('setParcelaPaga', parcela, true,
                (data) => {
                    callBackFunction(data);
                });
        }
        
        compraFactory.setParcelasPagas = (parcelas, callBackFunction) => {
            var params = {
                POST: true,
                data: parcelas
            }
            Conexao.ExecutaService('setParcelasPagas', params, true,
                (data) => {
                    callBackFunction(data);
                });
        }

        compraFactory.setAtualizaParcelas = (IdNotaFiscal, callBackFunction) => {
            Conexao.ExecutaService('setAtualizaParcelas', {IdNotaFiscal: IdNotaFiscal}, true,
                (data) => {
                    callBackFunction(data);
                });
        }

        compraFactory.getFornecedores = (params, callBackFunction) => {
            Conexao.ExecutaService('getFornecedores', params, false,
                (data) => {
                    callBackFunction(data);
                });
        }  

        compraFactory.getOrdemCompraSolta = (params, callBackFunction) => {
            Conexao.ExecutaService('getOrdemCompraSolta', params, false,
                (data) => {
                    callBackFunction(data);
                });
        }  

        compraFactory.setNotaFiscalOrdemCompra = (params, callBackFunction) => {
            Conexao.ExecutaService('setNotaFiscalOrdemCompra', params, false,
                (data) => {
                    callBackFunction(data);
                });
        }  

        compraFactory.getVinculoMedicao = (params, callBackFunction) => {
            Conexao.ExecutaService('getVinculoMedicao', params, false,
                (data) => {
                    callBackFunction(data);
                });
        }  

        compraFactory.vinculaMedicaoFornecedor = (params, callBackFunction) => {
            Conexao.ExecutaService('vinculaMedicaoFornecedor', params, false,
                (data) => {
                    callBackFunction(data);
                });
        }  

        compraFactory.vinculaMedicaoFuncionario = (params, callBackFunction) => {
            Conexao.ExecutaService('vinculaMedicaoFuncionario', params, false,
                (data) => {
                    callBackFunction(data);
                });
        }  

        compraFactory.getFuncionarioMedicao = (params, callBackFunction) => {
            Conexao.ExecutaService('getFuncionarioMedicao', params, false,
                (data) => {
                    callBackFunction(data);
                });
        }

        compraFactory.getFornecedorMedicao = (params, callBackFunction) => {
            Conexao.ExecutaService('getFornecedorMedicao', params, false,
                (data) => {
                    callBackFunction(data);
                });
        }

        compraFactory.setNotaFiscalApropriada = (params, callBackFunction) => {
            Conexao.ExecutaService('setNotaFiscalApropriada', params, false,
                (data) => {
                    callBackFunction(data);
                });
        }

        compraFactory.delNotaFiscalApropriada = (params, callBackFunction) => {
            Conexao.ExecutaService('delNotaFiscalApropriada', params, false,
                (data) => {
                    callBackFunction(data);
                });
        }

        compraFactory.getDataIniFimLancamento = (params, callBackFunction) => {
            Conexao.ExecutaService('getDataIniFimLancamento', params, false,
                (data) => {
                    callBackFunction(data);
                });
        }
        
        compraFactory.getNotaFiscalSefaz = (params, callBackFunction) => {
            Conexao.ExecutaService('getNotaFiscalSefaz', params, false,
                (data) => {
                    callBackFunction(data);
                });
        }

        compraFactory.setNotaSefazConstrucao = (params, callBackFunction) => {
            Conexao.ExecutaService('setNotaSefazConstrucao', params, true,
                (data) => {
                    callBackFunction(data);
                });
        }

        compraFactory.setSefazLancamento = (params, callBackFunction) => {
            Conexao.ExecutaService('setSefazLancamento', params, true,
                (data) => {
                    callBackFunction(data);
                });
        }

        compraFactory.delNotaFiscalSefaz = (params, callBackFunction) => {
            Conexao.ExecutaService('delNotaFiscalSefaz', params, false,
                (data) => {
                    callBackFunction(data);
                });
        }

        compraFactory.cancelaNotaFiscalSefaz = (params, callBackFunction) => {
            Conexao.ExecutaService('cancelaNotaFiscalSefaz', params, false,
                (data) => {
                    callBackFunction(data);
                });
        }

        compraFactory.getCertificado = (params, callBackFunction) => {
            Conexao.ExecutaService('getCertificado', params, false,
                (data) => {
                    callBackFunction(data);
                });
        }

        compraFactory.getCertificados = (params, callBackFunction) => {
            Conexao.ExecutaService('getCertificados', params, false,
                (data) => {
                    callBackFunction(data);
                });
        }

        compraFactory.delCertificado = (params, callBackFunction) => {
            Conexao.ExecutaService('delCertificado', params, true,
                (data) => {
                    callBackFunction(data);
                });
        }

        return compraFactory;
  }]);
